struct problem problemDef(int functionCode, FILE *fLandscape)
{
	int d;
	int dim;
	int i,j;
	int initDiff=0; // For each function, you can define a specific 
									// initialisation space. In that case, you also have
									// to set initDiff to a non zero value
	struct problem pb={0}; // Initialised just for my stupid compiler
	int scanNb;
	float z;


	pb.function=functionCode;	
	pb.epsilon = 0.00000;		// Acceptable error. Defalut value
	pb.objective = 0;       // Objective value. Default value
	pb.constraint=0; 				// Number of constraints. Default value
	pb.SS.valueNb=0;


	// Define the solution point, for test
	// NEEDED when param.stop = 2 
	// i.e. when stop criterion is distance_to_solution < epsilon
	for (d=0; d<30;d++)
	{
		pb.solution.x[d]=0;
	}


	// ------------------ Search space
	switch (pb.function)
	{   
#include "cec2005pb.c"
		case 0:			// Parabola
			pb.SS.D =3;// 30 	// Dimension

		for (d = 0; d < pb.SS.D; d++)
		{   
			pb.SS.min[d] = -100; // -100
			pb.SS.max[d] = 100;	// 100
			pb.SS.q.q[d] = 0;	// granularity/quantum/step   1 => integer  
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 
		}

		pb.evalMax = 6000;// 6000	// Max number of evaluations for each run
		pb.epsilon = 0.000;	//0.0001 Acceptable error
		pb.objective = 0;       // Objective value
		break;

		case 1:		// Griewank
			pb.SS.D = 10;	// 30   

		// Boundaries
		for (d = 0; d < pb.SS.D; d++) 
		{	
			pb.SS.min[d] = -600; // -100
			pb.SS.max[d] = 600; // 100
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 
		}

		pb.evalMax = 4000;	  // 9000 
		pb.epsilon = 0.000;	//0.0001 Acceptable error
		pb.objective = 0.000;       // Objective value
		break;

		case 2:		// Rosenbrock
			pb.SS.D = 30;	

		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{	
			pb.SS.min[d] = -30; pb.SS.max[d] = 30; 
		
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	      
		}

		pb.evalMax =300000; // 40000	
		pb.epsilon = 0.0001;	//0.0001 Acceptable error
		pb.objective = 0;       // Objective value
		break;

		case 3:		// Rastrigin
			pb.SS.D = 20;
		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] =-500; //-10; 
			pb.SS.max[d] =250; //10; 	  
			pb.SS.q.q[d] = 0;	
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 
		}
		pb.evalMax = 400000; // 40000
		pb.epsilon = 0.0001;	//0.0001 Acceptable error
		pb.objective = 0;       // Objective value
		break;


		case 4:		// Tripod
			pb.SS.D = 2;	// 2

		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = -100; // -100
			pb.SS.max[d] = 100; // 100
			pb.SS.q.q[d] = 0;	
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 
		}
		pb.epsilon=0.0001;		
		pb.evalMax = 10000 ; //10000; 
		pb.objective = 0; // Objective value
		break;

		case 5: // Ackley
			pb.SS.D = 30;	// Dimension 30

		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = -32; // -32
			pb.SS.max[d] = 32; // 32
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

		pb.evalMax = 100000; // 40000	
		pb.epsilon=0.000;
		pb.objective=0;
		break;

		case 6: // Center-bias test function
			pb.SS.D = 1;	// Dimension <=30

		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = -100; // 100
			pb.SS.max[d] = 100; // 100
			pb.SS.q.q[d] = 0;
			pb.SS.minS[d]=-105;
			pb.SS.maxS[d]=105; 	
		}

		pb.evalMax = 100; //
		pb.epsilon=0.00; 
		break;

		case 1007: // Pressure vessel (confinement method)
		pb.constraint=3;
		case 7: //  penalty method
			// Solution: (1.125, 0.625, 58.2901, 43.6927) => 7197.729
			// Solution: (1.125, 0.625, 55.8592, 57.7315) => 7197.729
			pb.SS.D=4;
/*
		pb.SS.min[0] = 1.125; pb.SS.max[0] = 12.5;
		pb.SS.q.q[0] = 0.0625;
		pb.SS.min[1] = 0.625; pb.SS.max[1] = 12.5; 
		pb.SS.q.q[1] = 0.0625;
		pb.SS.min[2] = 0.00000001; pb.SS.max[2] = 240; 
		pb.SS.q.q[2] = 0;
		pb.SS.min[3] = 0.00000001; pb.SS.max[3] = 240; 
		pb.SS.q.q[3] = 0;
*/
		pb.SS.min[0] = 0.0625; pb.SS.max[0] = 99;
		pb.SS.q.q[0] = 0.0625;
		pb.SS.min[1] = 0.0625; pb.SS.max[1] = 99; 
		pb.SS.q.q[1] = 0.0625; 
		pb.SS.min[2] = 10; pb.SS.max[2] = 200; 
		pb.SS.q.q[2] = 0;
		pb.SS.min[3] = 10; pb.SS.max[3] = 200; 
		pb.SS.q.q[3] = 0;

		for (d = 0; d < pb.SS.D; d++)                  
		{
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}
		pb.evalMax = 50000 ; 
		pb.epsilon = 0.00001; //0.0000000001;	
		pb.objective = 7197.72893; //7197.7289277771; 
		break;

		case 1008: 
		pb.constraint=5;
		case 8 : // Compression spring
			pb.SS.D=3;

		pb.SS.min[0] = 1; pb.SS.max[0] = 70; pb.SS.q.q[0] = 1;
		pb.SS.min[1] = 0.6; pb.SS.max[1] = 3; pb.SS.q.q[1] = 0;
		pb.SS.min[2] = 0.207; pb.SS.max[2] = 0.5; pb.SS.q.q[2] = 0.001;


		for (d = 0; d < pb.SS.D; d++)                  
		{
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}
		pb.evalMax = 20000 ; 
		pb.epsilon = 1.e-10;	
		pb.objective = 2.6254214578; 
		break;

		case 9: // Gear train

			pb.SS.D=4;

		for (d = 0; d < pb.SS.D; d++)                  
		{
			pb.SS.min[d]=12;
			pb.SS.max[d]=60;
			pb.SS.q.q[d] = 1;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

		pb.evalMax = 20000 ; 
		pb.epsilon = 1.e-13;	
		pb.objective =2.7e-12 ; 
		break;

		case 10: // Cellular phone
			pb.SS.D=2*10; //2*10  2*nb_of_stations

		for (d = 0; d < pb.SS.D; d++)                  
		{
			pb.SS.min[d]=0;
			pb.SS.max[d]=100;
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

		pb.evalMax = 20000 ; // 20000
		pb.epsilon = 1e-9;	
		pb.objective =  0.005530517; // Best known result (2010-01-03)
		// pb.epsilon=0; pb.objective=0;
		break;

		case 11: // PAPR/OFDM
			pb.SS.D=16;
		for (d = 0; d < pb.SS.D; d++)                  
		{
			pb.SS.min[d]=-1;
			pb.SS.max[d]=1;
			pb.SS.q.q[d] = 1;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

		pb.evalMax = 10000 ; 

		pb.epsilon = 0.000001;	//0.0001 Acceptable error
		// pb.objective = 0.01328;  // Objective value for T1
		pb.objective=0;

		f_papr=fopen("NNN.txt","r");
		for(j=0;j<aSize;j++)
		{
			for(i=0;i<pb.SS.D; i++)
				scanNb=fscanf(f_papr,"%f",&a[i][j]);
		}
		printf("\n Coefficients");
		for(j=0;j<aSize;j++)
		{
			printf("\n");
			for(i=0;i<pb.SS.D; i++)
			{
				printf("%f ",a[i][j]);
			}
		}

		break;

		case 12: // Schwefel
			pb.SS.D = 30;	

		// Boundaries
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = -500; // -32
			pb.SS.max[d] = 500; // 32
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

		pb.evalMax = 900000; 
		pb.epsilon=0.000;
		pb.objective=0;
			break;

			case 13: // Cutting stock  (see also perf()) 
				pb.SS.valueNb=5;
			pb.SS.D=0; for(d=0;d<pb.SS.valueNb;d++) pb.SS.D=pb.SS.D+pieceNb[d];
			// Boundaries
			for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = valueList[0];
			pb.SS.max[d] = valueList[4];
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

			pb.evalMax = 100000;	
			pb.epsilon = 0.00001;	
			pb.objective = 940;  

			break;	

			case 14: // Polygon, smallest perimeter
				pb.SS.D=13; // 2*(number of sides)-3 
			// Polar coordinates
			// The first point is fixed theta0=0, rho0=0
			// For the second point, the angle theta1 is 0
			// So the variables are
			// rho1
			// theta2 rho2
			// theta3 rho3
			// etc.

			for(d=0;d<pb.SS.D;d=d+2) // rho
		{
			pb.SS.min[d]=pi/(pb.SS.D+3); //0;
			pb.SS.max[d]=1;
		}

			for(d=1;d<pb.SS.D;d=d+2) // theta
		{
			pb.SS.min[d]=0; // 0
			pb.SS.max[d]=pi/2; // 0
		}


			for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		} 

			pb.evalMax = 100000 ; 
			pb.epsilon = 0.000000;	
			pb.objective=0;

			break;


			case 1015: // Constrained g13, with Confinement method
								// Optimum 0.0539498
			pb.constraint=3;
			case 15: // with Penalty method
			pb.SS.D=5;
			pb.epsConstr=0.0001;

			for(d=0;d<2;d++) 
		{
			pb.SS.min[d]=-2.3;
			pb.SS.max[d]=2.3;
		}


			for(d=2;d<pb.SS.D;d++) 
		{
			pb.SS.min[d]=-3.2;
			pb.SS.max[d]=3.2;
		}

		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		} 

			pb.evalMax = 100000; //340000 ; 
			pb.epsilon = 0.0000001; 
			pb.objective=0; //0.0539498;
			break;
			
		case 16: // G3 (constrained)
			pb.SS.D=10;
		pb.objective=0;
		for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = 0;
			pb.SS.max[d] = 1;
			pb.SS.q.q[d] = 0;	
		}
		pb.evalMax = 340000; //340000;
		pb.objective=0;
		pb.epsilon=1.e-6;
		
				for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		} 

		break;

			case 99: // Test

				pb.SS.D = 1;	// Dimension

			// Boundaries
			for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = 0;
			pb.SS.max[d] = 100;
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d]; 	
		}

			pb.evalMax = 500;		 
			break;	

			case 1000: // Landscape on the file fLandscape.txt
				// WARNING. Just valid for 1D function
				pb.SS.D = 1;	// Dimension
			scanNb=fscanf(fLandscape,"%i",&funct.N);

			pb.SS.min[0] = infinity;
			pb.SS.max[0] = -infinity;
			pb.SS.q.q[0] = 1;
			pb.SS.maxS[0]=pb.SS.max[0];
			pb.SS.minS[0]=pb.SS.min[0]; 

			for(d=0;d<funct.N;d++)
		{
			scanNb=fscanf(fLandscape,"%f",&z);funct.x[d]=z;
			if(z<pb.SS.min[0]) pb.SS.min[0]=z;
			if(z>pb.SS.max[0]) pb.SS.max[0]=z;

			scanNb=fscanf(fLandscape,"%f",&z);funct.fx[d]=z;
		}
			pb.evalMax = 100;
			break;

			case -1: // Trying to find a "good" repartition of N points in a D-space
			case -2:
			dim=30; // Dimension of the _future search space
			pb.nb=(int) (10 + 2 * sqrt(dim)); // Nb of positions
			pb.SS.D = dim*pb.nb;	// Dimension_of_the space*Nb_of_positions

			// Boundaries
			for (d = 0; d < pb.SS.D; d++)
		{
			pb.SS.min[d] = 0;
			pb.SS.max[d] = 1;
			pb.SS.q.q[d] = 0;
			pb.SS.maxS[d]=pb.SS.max[d];
			pb.SS.minS[d]=pb.SS.min[d];		
		}

			pb.evalMax = 100000*dim;
			pb.epsilon = 0.000;	
			pb.objective = 0;   		 
			break;	
	} // End of 	switch (pb.function)

	pb.SS.q.size = pb.SS.D;
	
	// Save the "real" search space
	// 
			for (d = 0; d < pb.SS.D; d++) 
		{
			pb.SS.maxR[d]=pb.SS.max[d];// Save the real search space
			pb.SS.minR[d]=pb.SS.min[d];
		}


	if(initDiff==0) // If no specific initialisation space
	{
		for (d = 0; d < pb.SS.D; d++)
		{  
			pb.SS.maxInit[d]=pb.SS.max[d];
			pb.SS.minInit[d]=pb.SS.min[d];
		}	 
	}
		return pb;
}