struct result PSO (struct param param, struct problem pb, int level) 
{  
	double c1,c2;
	int d; 
	struct fitness error={0}; 
	struct fitness errorI; 
	struct fitness errorInit; 
	struct fitness errorPrev;
		struct fitness f0;
	double errorTot;
	struct exploit ex;
	double explBestSize;

	double explRate[2];
	int g[SMax]; // Best informants
	int sBest; // Rank in g of the best of the bests
	int index[SMax], indexTemp[SMax];     
	int initLinks;	// Flag to (re)init or not the information links
	int initLinkNb;
	int initLinkNbMax;
	int iterBegin;
	int keep;
	int length;
	int LINKS[SMax][SMax];	// Information links
	int n,m; 
	int moved;	
	int noStop;
	double p;
	struct quantum qAdapt;
	struct result R={0};
	int rank;
	double rho;
	int s0=0;
	int s,s1; 
	int scanNb;
	int sInh;
	int t;
	int updateRho;
	struct xv xv, xvNorm;
	double w;
	float z;
	double zz;

	// For variograms and kriging
	struct krigin krigin;


	//aleaV.size=pb.SS.D;

	// -----------------------------------------------------
	// INITIALISATION

	p=param.p; 				// Probability threshold for random topology
	R.SW.S = param.S; // Size of the current swarm
	krigin.MRank=0; 					// Rank (in M) where to memorise a new position
	krigin.MSize=0; 					// Number of memorised positions

	// Positions
	if(param.init==-1) // Read from file 
	{
		f_init=fopen("f_initS20D30.txt","r"); // TO DO. The user should be in fact
		// asked for the name of the file
		// ***WARNING*** For the moment, NOT COMPATIBLE with the normalise option
		scanNb=	fscanf(f_init,"%i",&s0);
		if(s0!=R.SW.S)
		{
			printf("\nThe number of points (%i) in the file",s0);
			printf("\nis not consistent with the swarm size S (%i)",R.SW.S);
			ERROR(" ");
		}
		for (d = 0; d < pb.SS.D; d++)  
		{ 
			scanNb=fscanf(f_init,"%f",&z);
			R.SW.X[s].x[d]=z;		
		}
	}
	else
	{
		for (s = 0; s < R.SW.S; s++)   
		{
			R.SW.X[s]=initPos(param.init,R.SW.S, pb);
		}
	}

	// Velocities
	for (s = 0; s < R.SW.S; s++)
	{
		R.SW.V[s]=initVel(param.initVel,R.SW.S,pb, R.SW.X,s);	
	}

	// Distribution methods
	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.R[s]=initDistrib(param.R);
	}

	// Coefficients (different w and c)
	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.w[s]=initW(param);
		R.SW.c1[s]=initC1(param); 
		R.SW.c2[s]=initC2(param);	
	}

	// Prepare possible adaptive quantisation
	qAdapt=quantAdapt(R.SW, pb, param.quant);

	// Discrete values
	// Note: may be reoved if you are sure that the initialisation
	//        takes discretisation into account (or if there is none)
	for (s = 0; s < R.SW.S; s++) 
	{
		R.SW.X[s]=discrete(R.SW.X[s], pb, param.quant,qAdapt);
	}
	
	// Note: at this point no confinement is needed:
	// initialisation is supposed to be OK from this point of view

	// Memorise the positions for Krigin
	for (s = 0; s < R.SW.S; s++)   
	{
		krigin.M[krigin.MRank]=R.SW.X[s];

		if(krigin.MSize<MMax-1)
		{
			krigin.MSize=krigin.MSize+1;
			krigin.MRank=krigin.MRank+1;
		}
		else krigin.MRank=0; // We re-use the memory cyclically. From now on, MSize=MMax
	}

	// First evaluations
	for (s = 0; s < R.SW.S; s++) 
	{	
		R.SW.X[s].f =
			perf (R.SW.X[s], pb, 0, 0, 0,param.normalise);

		R.SW.P[s] = R.SW.X[s];	// Best position = current one
		R.SW.P[s].improved = 0;	// No improvement
		R.SW.XPrev[s]=R.SW.X[s];
	}

	// If the number max of evaluations is smaller than 
	// the swarm size, just keep evalMax particles, and finish
	if (R.SW.S>pb.evalMax) R.SW.S=pb.evalMax;	
	R.nEval = R.SW.S;

	// Find the best and the worst
	// 	Remember that f is fabs(fitness-objective)
	// 	We want to minimise it
	R.SW.best = 0;
	R.SW.worst=0;
	errorPrev=R.SW.P[R.SW.best].f;

	for (s = 1; s < R.SW.S; s++)     
	{
		if(betterThan(R.SW.P[s].f,errorPrev))
		{
			R.SW.best = s;
			errorPrev=R.SW.P[s].f;
		}
		if(betterThan(R.SW.P[R.SW.worst].f,R.SW.P[s].f)==1) R.SW.worst=s;
	}
	errorInit=errorPrev; // Just for information
	error=errorPrev;


	// Display the best
	printf( "\n Best value after init. %f ", errorPrev.f[0] );
	if(pb.constraint>0)
	{
		printf("\n Constraints (should be < 0) ");
		for(n=0;n<pb.constraint;n++) printf("%f ",errorPrev.f[n+1]);
	}

	//fprintf(f_run,"\n Best value after init. %f ", errorPrev );
	//printf( "\n Position :\n" );
	//for ( d = 0; d < pb.SS.D; d++ ) printf( " %f", R.SW.P[R.SW.best].x[d] );

	initLinks = 1;		// So that information links will beinitialized
	// Note: It is also a flag saying "No improvement"
	switch(param.initLinkNbMax)
	{
		default:initLinkNbMax=param.initLinkNbMax;
		break;
		case 0: initLinkNbMax=R.SW.S/2;
		break;
		case -1:    initLinkNbMax=2; //(int)(0.5/param.p);
		break;
	}
	initLinkNb=0; // Number of iterations without checking if structural adaptation
	// is needed
	errorI=errorPrev;

	nEval=0;
	noStop=0;
	iter=0; iterBegin=0;
	rho=param.size_LEA;
	explRate[1]=param.force_LEA;
	explRate[0]=explRate[1]; // Previous exploitation rate
	updateRho=0; // For adaptive LEA option

	// ---------------------------------------------- ITERATIONS
	while (noStop == 0) 
	{
		//printf("\niter %i",iter);
		//fprintf(f_run,"\niter %i",iter); 
		iter=iter+1;

		if (initLinks==1)	// Random topology
		{

			// Who informs who, at random
			for (s = 0; s < R.SW.S; s++)
			{	
				for (m = 0; m < R.SW.S; m++)
				{		    
					if (alea (0, 1)<p) LINKS[m][s] = 1;	// Probabilistic method
					else LINKS[m][s] = 0;
				}
			}
			//fprintf(f_run,"\nendLinks");
			// Each particle informs itself
			for (m = 0; m < R.SW.S; m++)
			{
				LINKS[m][m] = 1;	     
			}	  
		}

		// Prepare the move. Initialisation of some variables
		//printf("\nIteration %i",iter);
		for (s = 0; s < R.SW.S; s++)
		{  
			index[s]=s;
			R.SW.Pp[s] = R.SW.P[s]; // Save the previous best, for information
			R.SW.lBest[s]=0; // Initialise the flags (for information)
			R.SW.X[s].forced=0; // Non "forced" move (for the moment)
			R.SW.P[s].forced=0;
		}

		explForced=0; // In order the evaluate the exploitation rate	

		// May define a random permutation of the particles	
		switch (param.randOrder)
		{
			default: // The same sequence for each iteration
				break;

			case 1: // Random permutation before each move of the swarm
				length=R.SW.S;
			for (s=0;s<length;s++) indexTemp[s]=index[s];

			for (s=0;s<R.SW.S;s++)
			{
				rank=alea_integer(0,length-1);
				index[s]=indexTemp[rank];
				if (rank<length-1)	// Compact
				{
					for (t=rank;t<length;t++)
						indexTemp[t]=indexTemp[t+1];
				}					
				length=length-1;
			}
			break;			
		}
		// Find the best informants
		for (s0 = 0; s0 < R.SW.S; s0++)	// For each particle ...
		{	
			s=index[s0];
			// ... find the first informant
			s1 = 0;    
			while (LINKS[s1][s] == 0)	s1++;					
			if (s1 >= R.SW.S)	{s1 = s;} // If no informant at all, just himself
			else
			{
				// Best informant			
				g[s] = s1;	
				for (m = s1; m < R.SW.S; m++) 
				{	    
					if (LINKS[m][s] == 1 && betterThan(R.SW.P[m].f,R.SW.P[g[s]].f)==1)
						g[s] = m;
				}
			}	
			R.SW.lBest[g[s]]=1; // Particle g[s] is a best informant
		}

		// Best of the best of all informants
		sBest=0;
		for (s = 1; s < R.SW.S; s++)
		{	
			if(betterThan(R.SW.P[g[s]].f, R.SW.P[g[sBest]].f)==1) sBest=s;
		}

		// Define the exploitation areas	
		ex=exploitArea(R.SW, pb.SS,param, updateRho, explRate,ex.rho); 

		// For information, size of the best local area
		explBestSize=1;
		for(d=0;d<pb.SS.D;d++)
		{
			explBestSize=
				explBestSize*(ex.exI[g[sBest]].max[d]-ex.exI[g[sBest]].min[d]);
		}
		
		// Prepare adaptive quantisation...	
		// Note: it could be put _inside_ the loop on particls for (s0=...
		
		qAdapt=quantAdapt(R.SW, pb,param.quant);
				
		// Loop on particles, for move
		for (s0 = 0; s0 < R.SW.S; s0++)
		{			
			s=index[s0];
			xv.x.forced=0;
			moved=0;
			// May "force" a particle inside a LEA (local exploitation area)
			if(alea(0,1)<param.force_LEA)
			{
				switch(param.choose_LEA)
				{
					case 0: // Normal move
					break;

					case 1: // In the LEA of some particles
						xv=drawLEA(param, R.SW, s, g[s], ex, krigin );	
					break;

					case 2: // In the best local area
						if(R.SW.P[g[sBest]].forced==1 && param.draw_LEA==0)
								 break; // Middle already sampled
		 
						xv=drawLEA(param, R.SW, s, g[sBest], ex, krigin );
						R.SW.P[g[sBest]].forced=1; // Already used
				} // End of switch choose_LEA
			}
		
			// Inheritance of the coefficient values
		// Of course, it does make sense only if w, c1, c2 may be different
		// for each particle (see param.W, param.C1, param.C2)
		
		if(alea(0,1)<param.inheritance)  sInh=g[s]; 	
		else sInh=s;
		w=R.SW.w[sInh];
		c1=R.SW.c1[sInh];
		c2=R.SW.c2[sInh];
//printf("\nPSO 344 sInh %i, w, c1, c2 %f %f %f",sInh, w,c1,c2);	
	
		// Mutation of the coefficients
		// Note: hard-coded functions. Could be modified
		if(alea(0,1)<param.mutation[0]) w=min(max(w/2,alea_normal(w,w/param.S)),1);
		if(alea(0,1)<param.mutation[1]) c1=min(max(c1/2,alea_normal(c1,c1/param.S)),1.5*c1);
		if(alea(0,1)<param.mutation[2]) c2=min(max(c1/2,alea_normal(c2,c2/param.S)),1.5*c2);
		
//printf("\nPSO 350 sInh %i, w, c1, c2 %f %f %f",sInh, w,c1,c2);	
	
		// Assign the coefficients
		R.SW.w[s]=w;
		R.SW.c1[s]=c1;
		R.SW.c2[s]=c2;
	
		// Memorise the previous fitness
		f0=R.SW.X[s].f;
			// Normal move (more precisely, non forced one)
			// It may be either a classical move or a "nearer is better" one	
	
				xvNorm=move(R,s, g[s], pb, param)	;
	
			// Discrete values
			if(xv.x.forced>0)
				xv.x=discrete(xv.x, pb, param.quant,qAdapt);
				
			xvNorm.x=discrete(xvNorm.x, pb, param.quant,qAdapt);
evaluate:
			// Confinement and evaluation
			if(xv.x.forced>0)
			{
				xv=confinement(xv,pb,param,R.SW.R[s]);
			}

			xvNorm=confinement(xvNorm,pb,param,R.SW.R[s]);

			// Modify the result. If forced, keep the best
			if(xv.x.forced==0) keep=0; // Normal move
			else
			{
				if(betterThan(xvNorm.x.f,xv.x.f)) keep=0; // There has been a forced move
																								// but not better
				else keep=1; // Forced move is better
			}
		
			if(keep==0) 
			{
				R.SW.X[s]=xvNorm.x;
				R.SW.V[s]=xvNorm.v;
			}
			else
			{
				R.SW.X[s]=xv.x;
				R.SW.V[s]=xv.v;	
			}
	
			// If too many evaluations => STOP
			if (nEval >= pb.evalMax) goto end;	 

			// Update the best previous position
			if(betterThan(R.SW.X[s].f,R.SW.P[s].f)==1) // Improvement
			{		
				R.SW.P[s] = R.SW.X[s];
				R.SW.P[s].forced=0; // Not used
					 		
				// Update the best of the bests
				if(betterThan(R.SW.P[s].f,R.SW.P[R.SW.best].f)==1)
				{		
					R.SW.best = s;			
				}				
			}
		
		// May try the opposite
			{
				if(param.opposite==1 && moved==0 && betterThan(R.SW.X[s].f,f0)==0)
				{
					for (d = 0; d < pb.SS.D; d++)
					{	
					xvNorm.x.x[d] = R.SW.X[s].x[d]-2*R.SW.V[s].v[d];
					xvNorm.v.v[d]= -R.SW.V[s].v[d];
				}	
				xv.x.forced=0;
				moved=1; goto evaluate;
				}
			}


			// Update the worst
			if(betterThan(R.SW.P[R.SW.worst].f,R.SW.P[s].f)==1)
			{		
				R.SW.worst = s;			
			}				

			// Save the previous position
			R.SW.XPrev[s]=R.SW.X[s];
			
			// Memorise for Krigin estimation
			if(param.draw_LEA==4)
			{
				krigin.M[krigin.MRank]=R.SW.X[s];

				if(krigin.MSize<MMax-1)
				{
					krigin.MSize=krigin.MSize+1;
					krigin.MRank=krigin.MRank+1;
				}
				else krigin.MRank=0; // We re-use the memory cyclically 
			}
		}			// End of "for (s0=0 ...  "	


		// Exploitation rate (how many particles are in a LEA?) 
		explRate[0]=explRate[1]; // Save the previous one
		explRate[1]=explNb(R.SW,ex); 
		// Save it for further analysis
		if(param.explSave>0)
		{
			fprintf(f_expl, "explBestSize %f ",explBestSize);
			fprintf(f_expl,"explRate %f\n",explRate[1]);
		}
		
		updateRho=1; // To use in exploitArea in case of adaptive option,
		// supposed to "balance" exploitation/exploration

		// Check if improvement since last structural adaptation	
		initLinkNb=initLinkNb+1;
		initLinks=0;
		if(initLinkNb>=initLinkNbMax)
		{
			initLinkNb=0;

			error = R.SW.P[R.SW.best].f;
			if (betterThan(error,errorPrev)==1)	// Improvement
			{		
				initLinks = 0;							
			}
			else			// No improvement
			{			
				initLinks = 1;	// Information links will be	reinitialized	
			}

			// Case 0: update the links if there has been NO improvemnt
			// Case 1: the contrary
			if(param.initLink==1) initLinks=1-initLinks;

			// Save error	
			errorI=error;
			errorPrev = error;
		}	

		// End of the iteration 
		//May be a "premature" end if there has been too many evaluations
		end:

			// Prepare the curve "success rate" vs FEmax
			// (for unconstrained optim.)
			if(error.f[0]<=pb.epsilon) 
		{				
			for(n=FEclass;n<FEmaxSize;n++)
				successFlag[run][n]=1;
		}

			if(nEval>FEmax[FEclass])
		{
			// Prepare the curve "mean best" vs FEmax
			best[run][FEclass]=error.f[0];	

			FEclass=FEclass+1;
		}

			// Decide to stop or not, depending on the chosen criterion
			switch (param.stop)
		{		
			case 0:
				errorTot=errorFC(error);

				if (errorTot > pb.epsilon && nEval < pb.evalMax)
					noStop = 0;	// Won't stop
				else
					noStop = 1;	// Will stop
				break;

			case 1:			
				if (nEval < pb.evalMax)
					noStop = 0;	// Won't stop
				else
					noStop = 1;	// Will stop
				break;		
		}

			// May reinitialise "bad" particles (i.e. selection)
			if(noStop==0 && param.select>0) 
		{
			R.SW=swarmSelect(R.SW,param.select, pb);
		}
	} // End of "while nostop ...


	// printf( "\n and the winner is ... %i", R.SW.best );			
	// fprintf( f_stag, "\nEND" );
	
	// Convergence rate, just for information
	R.convRate=(errorInit.f[0]-error.f[0])/errorInit.f[0];
	
	// Final number of evaluations
	R.nEval=nEval;
	// Final fitness
	R.error = R.SW.P[R.SW.best].f;
	return R;  
}
