struct xv move(struct result R, int s, int g, struct problem pb, struct param param)
{
double c1,c2;
int d;
double dist;
double distMin;
int i;
struct position p1,p2,pivot,pext;
double radius2;
int s2;
struct velocity GX;
struct velocity PX;
double vDamp=1;
struct xv xv;
double w;
double zz,zzz;

			xv.x.size=pb.SS.D;
			xv.v.size=pb.SS.D;
			xv.x.f=R.SW.X[s].f; // In case the position won't be re-evaluated

	if(param.NisB>0) // "Nearer is better" strategy
	{
		p1=R.SW.P[g];
		// Find the nearest "good" position p2 
		if(s>0) s2=0; else s2=1;
		distMin=distanceL(p1,R.SW.P[s2],2); // Euclidean distance
		
		 for(i=0;i<param.S;i++)
		 {
		 		if(i==s) continue;

				dist=distanceL(p1,R.SW.P[i],2); 
				if(dist<distMin)
				{
					distMin=dist;
					s2=i;
				}
		
		}
		// Define the pivot, p or g
		if(betterThan(R.SW.P[s2].f,p1.f)) {pivot=R.SW.P[s2]; pext=p1;}
		else {pivot=p1;pext=R.SW.P[s2];}
			
		
		// Draw at random in a hypersphere
		radius2=NisBD*distanceL(pivot,pext,2); // Euclidean distance
		xv.x=alea_sphere(pb.SS.D, pivot, 0,radius2,-1, -1); // Uniform distribution
	
		// Note: velocity is not used
	
		return xv;
	}

			w=R.SW.w[s];
			c1=R.SW.c1[s];
			c2=R.SW.c2[s];
			
			// Exploration tendency

			// if(posPrev.f>pos0.f) vDamp=0; // If improvement, slow down
			// else vDamp=1;

			for (d = 0; d < pb.SS.D; d++)
			{
				xv.v.v[d]=vDamp*w*R.SW.V[s].v[d];
			}

			// Prepare Exploitation tendency
			for (d = 0; d < pb.SS.D; d++) // p-x
			{
				PX.v[d]= R.SW.P[s].x[d] - R.SW.X[s].x[d];
			}				
			PX.size=pb.SS.D; 

			if(g!=s)
			{
				for (d = 0; d < pb.SS.D; d++) // g-x
				{
					GX.v[d]= R.SW.P[g].x[d] - R.SW.X[s].x[d];
				}
				GX.size=pb.SS.D;
			}

			// Exploitation tendencies
			switch(R.SW.R[s])
			{			
				default: 
				case0:
					for (d = 0; d < pb.SS.D; d++)
				{	
					zz=alea(0, c1);
				xv.v.v[d]=xv.v.v[d] +	zz*PX.v[d];

						if(param.nonLinear>0)	 xv.v.v[d]=xv.v.v[d] +
						zz*PX.v[d]*pow(PX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
					// zz*pow(PX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
				}

					if (g!=s) // If the best neighbour is not the particle itself
				{
					for (d = 0; d < pb.SS.D; d++)
					{	
						zz=alea(0,c2);
						xv.v.v[d]=xv.v.v[d] +	zz * GX.v[d];	

						if(param.nonLinear>0)	xv.v.v[d]=xv.v.v[d] +
						zz*GX.v[d]*pow(GX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
							//zz*pow(GX.v[d]/( pb.SS.max[d]-pb.SS.min[d] ),param.nonLinearCoeff[0]);
					}
				}
					break;	

				case 1:		// Gaussian distribution	
					for (d = 0; d < pb.SS.D; d++)
				{	
					xv.v.v[d]=xv.v.v[d]
						+	c1*alea_normal(alea(0,1), param.sigma)*PX.v[d];
				
				}

					if (g!=s)
				{
					for (d = 0; d < pb.SS.D; d++)
					{								
						xv.v.v[d]=xv.v.v[d]
							+	c2*alea_normal(alea(0,1), param.sigma) * GX.v[d];			
					}
				}
					break;

				case 2: // Decreasing function of the 1D distance 
								// (see also the parameter distPow)
				case2: 
					for (d = 0; d < pb.SS.D; d++) // Uniform
				{	
					 xv.v.v[d]=xv.v.v[d] +	c1*alea(0, 1)*PX.v[d];
				}

					if (g!=s) // If the best neighbour is not the particle itself
				{
					for (d = 0; d < pb.SS.D; d++) // Distance decreasing
					{	
						zz=fabs(GX.v[d])/(pb.SS.max[d]-pb.SS.min[d]);// Relative distance
						zzz=(1-zz); 
	
						xv.v.v[d]=xv.v.v[d] 
							+	c2*alea(0,1) *pow(zzz,param.distPow) *GX.v[d];			
					}
				}
					break;
					
				case 3:
				if(alea(0,1)<0.5) goto case0; 
				goto case2;
			}

			// Update the position
			for (d = 0; d < pb.SS.D; d++)
			{	
				xv.x.x[d] = R.SW.X[s].x[d] + xv.v.v[d];	
			}

			return xv;
			}
